package Kumera;

####
##
## This code is distributed under the Open Source Artistic Licence
## http://www.opensource.org/licenses/artistic-license.html
##
## Kumera copyright (c) 2002, CyberCyberCyberCyber Pty Ltd.
## http://www.cyber4.org/kumera/index.html
##
## $Log: Kumera.pm,v $
## Revision 1.3  2002/10/14 15:28:54  grumpy
## New configuration options
##
## Revision 1.2  2002/10/13 16:57:39  grumpy
##
## Added 2002 copyright notice.
##
##
####

require Exporter;
@ISA = qw/Exporter/;

@EXPORT = qw/$libs $script_path $XMLConfig/;
@EXPORT_OK = qw/encode decode $DEBUG _debug/;
%EXPORT_TAGS = (
        SESSION => [qw/encode decode/],
        DEBUG => [qw/$DEBUG _debug/],
    );

####
##
## Beginning of script configuration section.
##
## The only thind, you the installer, needto change is the first
## setting of $BaseDir. Everything should flow on from that.
##
####

# This is the BaseDir variable. Everything sits under this, and
# so it should be the only thing you need to configure.
$BaseDir = '/home/httpd';

# The location of the configuration file, which contains all the
# other information about where files site and so on.
$XMLConfig = "$BaseDir/data/conf/config.xml";

# Setting this to a non-zero value will allow debug messages
# to be activated by appending ?debug=<value> to the end of a URL
# This should not be left on in a production system!
$DEBUG = 0;

# The Directory that Kumera/Base.pm and the other library files sit.
$libs = "$BaseDir/lib";

# The web path that the scripts live in. This only needs to be
# changed it you're running something like mod_perl and have 
# a different path for the scripts.
$script_path = '/cgi-bin';

# The permissions that files are set to. This works with the installation
# # of the directories as having a group and permissions of 2775.
$file_perms = 0664;

# The joinging character for the two session variables. Can be anything
# except ';'
my $JOIN = 'g';

####
##
## End of script configuration section.
##
####

# take an array of items and turns them into a (mostly encrypted) string
sub encode {

    return join $JOIN, map { unpack 'H*', $_ } @{ $_[0] } if $_[0];

    return '';
}

sub decode {

    # if there is data to unpack, then do it
    return [ map { pack 'H*', $_ } split /$JOIN/, $_[0] ] if $_[0];

    # else return an empty list
    return [];
}

sub _debug {

    # grab the package name if given
    my $name = 'Kumera';
    if (@_ == 3) {

        # pop off the class name
        my $type = shift;

        # and build the display name
        $name = ref $type || $type;
    }

    # if the value is undefined, then have an alert
    print 'DEBUG('.$name.') - ', $_[0], '=>', (defined $_[1] ? $_[1] : "undefined"), "\n" if $DEBUG;
}

1;
