#!/usr/bin/perl -wT
use strict;

####
##
## This code is distributed under the Open Source Artistic Licence
## http://www.opensource.org/licenses/artistic-license.html
##
## Kumera copyright (c) 2002, CyberCyberCyberCyber Pty Ltd.
## http://www.cyber4.org/kumera/index.html
##
## $Log: login.cgi,v $
## Revision 1.3  2002/10/14 15:30:08  grumpy
## changes to 0
##
## Revision 1.2  2002/10/13 16:57:09  grumpy
##
## Added focus to user_if field.
##
##
####

BEGIN {
    $ENV{'PATH'} = '/bin;/usr/bin;/usr/local/bin';
    $| = 1;
    push @INC, '.';
    require Kumera;
    Kumera->import(qw/:DEFAULT :SESSION :DEBUG/);
    push @INC, $Kumera::libs;
}

use CGI qw/:standard/;
use CGI::Carp qw/fatalsToBrowser/;

# redefine $DEBUG, check that it is the same as the paramater from the URL
$DEBUG = $DEBUG && param('debug') eq $DEBUG;

print header(-type => 'text/plain') if $DEBUG;

# put this after the debug settings, so we can grab its output
use Kumera::Base;

my ($path_info, $session_id) = split /;/, path_info();
$path_info = $path_info && $path_info =~ /^([A-Za-z0-9\/_.]+)$/ ? $1 : '';
$session_id = '' unless $session_id;

my ($user_id, $last_activity) = @{ decode($session_id) };
$user_id = '' unless $user_id;
$last_activity = '' unless $last_activity;

# build a new session
$session_id = encode([param('user_id'), time()]);

# build a config object
my $config = new Kumera::Base({ PATH_INFO => $path_info });

# fix path_info
$path_info = $config->getPathInfo();

####
##
## From here it is uniquely login.cgi
##
####


my $message = 'Please enter your username and password.';

# check if the user is valid (will have more processing eventually)
$message = 'Your session timed out.' if ($last_activity && $last_activity =~ /^\d+$/ && $last_activity + $config->getParameter('timeout') < time());

# now depending if they are valid, we do different things
if (defined param('action') && param('action') eq 'do_login') {

    # if have submitted the form, check if they are valid
    if ($config->validate(param('user_id'), param('password'))) {

        # if a path_info has been supplied then use that, else use the default
        $path_info = $config->getBrowseFilename('index') unless $path_info;

        print redirect(-uri => $script_path.'/browse.cgi'.$path_info.';'.$session_id);

        exit;

    } else {
        $message = 'That username/password was not correct.';
    }
}

# default action, print the login form
print
    header,
    start_html(-title => 'login', -onLoad => 'document.this_form.user_id.focus();'),
    start_form(-action => script_name().$path_info, -name => 'this_form'),
    hidden(-name => 'action', -value => 'do_login'),
    table(
        Tr({-bgcolor => '#ffffff'},
            [
                td({-valign => 'top', -colspan => 2}, b($message)),
                td({-valign => 'top'},
                    [
                        b('username'),
                        textfield(-name => 'user_id', -value => $user_id)
                    ]
                ),
                td({-valign => 'top'},
                    [
                        b('password'),
                        password_field(-name => 'password')
                    ]
                ),
                td({-valign => 'top', -align => 'right', -colspan => 2}, submit(-value => 'log on')),
            ]
        )
    ),
    end_form,
    end_html;
