#!/usr/bin/perl -wT
use strict;

####
##
## This code is distributed under the Open Source Artistic Licence
## http://www.opensource.org/licenses/artistic-license.html
##
## Kumera copyright (c) 2002, CyberCyberCyberCyber Pty Ltd.
## http://www.cyber4.org/kumera/index.html
##
## $Log: print.cgi,v $
## Revision 1.3  2002/10/14 15:30:08  grumpy
## changes to 0
##
## Revision 1.2  2002/10/13 16:57:39  grumpy
##
## Added 2002 copyright notice.
##
##
####

BEGIN {
    $ENV{'PATH'} = '/bin;/usr/bin;/usr/local/bin';
    $| = 1;
    push @INC, '.';
    require Kumera;
    Kumera->import(qw/:DEFAULT :SESSION :DEBUG/);
    push @INC, $Kumera::libs;
}

use CGI qw/:standard/;
use CGI::Carp qw/fatalsToBrowser/;

use HTML::TreeBuilder;
use URI;

# redefine $DEBUG, check that it is the same as the paramater from the URL
$DEBUG = $DEBUG && param('debug') eq $DEBUG;

print header(-type => 'text/plain') if $DEBUG;

# put this after the debug setting so we can grab its output
use Kumera::Print;

my ($path_info, $session_id) = split /;/, path_info();
$path_info = $path_info && $path_info =~ /^([A-Za-z0-9\/_.]+)$/ ? $1 : '';
$session_id = '' unless $session_id;

my ($user_id, $last_activity) = @{ decode($session_id) };
$user_id = '' unless $user_id;
$last_activity = '' unless $last_activity;

# build a new session
$session_id = encode([param('user_id'), time()]);

# build a config object
my $print = new Kumera::Print({ USER_ID => $user_id, PATH_INFO => $path_info });

# fix path_info
$path_info = $print->getPathInfo;

####
##
## From here it is uniquely print.cgi
##
####

use HTML::TreeBuilder;

# parse in the file that we need
my $htmlTree = new HTML::TreeBuilder;

$htmlTree->parse($print->getPrintFile);

# these don't seem to work to well (that is, there is no difference in the output)

my $target_url = new URI('http://'.server_name().$print->getTemplatePathInfo);

$print->_debug('target_url', $target_url);
$print->_debug('path_info', $path_info);

# helper code
my %links =
    (
        a => 'href',
        img => 'src',
        form => 'action',
        link => 'href',
        frame => 'src'
    );

my @javascript =
    (
        'onmouseover',
        'onmouseout',
    );

# and then do the traverse,
# here we want to make all href and src absolute
$htmlTree->traverse
            (
                sub {

                    my $element = shift;
                    my $start  = shift;

                    # if the start of a tag, then process it for URL translation
                    return 1 unless $start;

                    # work out if we want to deal with this one
                    my $attr = $links{ lc $element->tag() } or return 1;
                    my $relative_url = $element->attr($attr) or return 1;

                    # work out the absoulte url from the realtive one given
                    my $absolute_url = URI->new_abs($relative_url, $target_url);

                    $print->_debug('absolute_url', $absolute_url->as_string);

                    # and change the attribute to an absolute one
                    $element->attr($attr, $absolute_url);

                    # now strip out the javascript event handlers, just in case
                    map { $element->attr($_, 'return false;') if $element->attr($_) } @javascript;

                    return 1;
                },
                1
            );

# try this then
%HTML::Element::optionalEndTag = map { $_ => 1 } qw(dt dd); # option th tr td)
print header, $htmlTree->as_HTML;

