#!/usr/bin/perl -wT
use strict;

####
##
## This code is distributed under the Open Source Artistic Licence
## http://www.opensource.org/licenses/artistic-license.html
##
## Kumera copyright (c) 2002, CyberCyberCyberCyber Pty Ltd.
## http://www.cyber4.org/kumera/index.html
##
## $Log: upload.cgi,v $
## Revision 1.3  2002/10/14 15:30:08  grumpy
## changes to 0
##
## Revision 1.2  2002/10/13 16:57:39  grumpy
##
## Added 2002 copyright notice.
##
##
####

BEGIN {
    $ENV{'PATH'} = '/bin;/usr/bin;/usr/local/bin';
    $| = 1;
    push @INC, '.';
    require Kumera;
    Kumera->import(qw/:DEFAULT :SESSION :DEBUG/);
    push @INC, $Kumera::libs;
}

use CGI qw/:standard/;
use CGI::Carp qw/fatalsToBrowser/;

# redefine $DEBUG, check that it is the same as the paramater from the URL
$DEBUG = $DEBUG && param('debug') eq $DEBUG;

print header(-type => 'text/plain') if $DEBUG;

# put this after the debug setting so we can grab its output
use Kumera::Upload;

my ($path_info, $session_id) = split /;/, path_info();
$path_info = $path_info && $path_info =~ /^([A-Za-z0-9\/_.]+)$/ ? $1 : '';
$session_id = '' unless $session_id;

my ($user_id, $last_activity) = @{ decode($session_id) };
$user_id = '' unless $user_id;
$last_activity = '' unless $last_activity;

# build a new $session_id
$session_id = encode([$user_id, time()]);

# build the object
my $upload = new Kumera::Upload({ PATH_INFO => $path_info, USER_ID => $user_id });

# fix path_info
$path_info = $upload->getPathInfo;

# check if the user is valid (will have more processing eventually)
if
(
    !$upload->getName($user_id) ||
    $last_activity !~ /^\d+$/ ||
    $last_activity + $upload->getParameter('timeout') < time() ||
    !$upload->hasPermission('edit')
)
{
    print redirect(-uri => $script_path.'/login.cgi'.$path_info.';'.$session_id);
    exit;
}

####
##
## From here it is uniquely upload.cgi
##
####

print
    header,
    start_html(-title => 'upload');

my $table_rows = '';

if (defined param('action') && param('action') eq 'do_commit') {

    my @upload_list = $upload->processUploadList(param('upload_list'));
    if (@upload_list) {

        foreach my $upload_entry (@upload_list) {

            $table_rows .=
                Tr
                    ({-bgcolor => '#ffffff'},
                    td(a({-href => $script_path.'/browse.cgi'.$upload_entry.';'.$session_id}, $upload_entry))
                );
        }

        $table_rows .= Tr({-bgcolor => '#ffffff'}, td('finished'));

        # and display the upload_list to the user
        print
            table($table_rows), br,
            br;

    }

}

my @upload_list = $upload->getUploadList;
$table_rows = Tr
                (
                    {-bgcolor => '#ffffff'},
                    td({-colspan => 2}, b('filename')),
                );


if (@upload_list) {

    foreach my $upload_entry (@upload_list) {

        # this will reset the checked value for a return call
        param(-name => 'upload_list', -value => $upload_entry);

        $table_rows .=
            Tr
                ({-bgcolor => '#ffffff'},
                td(checkbox(-name => 'upload_list', -value => $upload_entry, -checked => 1, -label => '')),
                td(a({-href => $script_path.'/browse.cgi'.$upload_entry.';'.$session_id}, $upload_entry))
            );
    }

    $table_rows .= Tr({-bgcolor => '#ffffff'}, td({-colspan => 2, -align => 'right'}, submit(-value => 'upload')));

    # and display the upload_list to the user
    print
        start_form(-action => script_name().path_info(), -method => 'POST'),
        hidden(-name => 'action', -value => 'do_commit'),
        table($table_rows),
        end_form;
} else {

    print 'no files to upload', br;

}

print
    $upload->menu({browse => 1, logout => 1}, $path_info.';'.$session_id),
    end_html;

